#[doc = "Register `ST0` reader"]
pub struct R(crate::R<ST0_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<ST0_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<ST0_SPEC>> for R {
    fn from(reader: crate::R<ST0_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `ST0` writer"]
pub struct W(crate::W<ST0_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<ST0_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<ST0_SPEC>> for W {
    fn from(writer: crate::W<ST0_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `ST_LS` reader - Status register for UDB\\[n\\]"]
pub struct ST_LS_R(crate::FieldReader<u8, u8>);
impl ST_LS_R {
    pub(crate) fn new(bits: u8) -> Self {
        ST_LS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for ST_LS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `ST_MS` reader - Status register for UDB\\[n+1\\]"]
pub struct ST_MS_R(crate::FieldReader<u8, u8>);
impl ST_MS_R {
    pub(crate) fn new(bits: u8) -> Self {
        ST_MS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for ST_MS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:7 - Status register for UDB\\[n\\]"]
    #[inline(always)]
    pub fn st_ls(&self) -> ST_LS_R {
        ST_LS_R::new((self.bits & 0xff) as u8)
    }
    #[doc = "Bits 8:15 - Status register for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn st_ms(&self) -> ST_MS_R {
        ST_MS_R::new(((self.bits >> 8) & 0xff) as u8)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Status Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [st0](index.html) module"]
pub struct ST0_SPEC;
impl crate::RegisterSpec for ST0_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [st0::R](R) reader structure"]
impl crate::Readable for ST0_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [st0::W](W) writer structure"]
impl crate::Writable for ST0_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets ST0 to value 0"]
impl crate::Resettable for ST0_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
